<!--应用接入-->
<template>
  <div style="position: relative">
    <el-collapse v-model="activeName" accordion ref="collapse" v-resize="resize" style="margin-bottom:20px">
      <el-collapse-item name="1">
        <template slot="title">
          <div class="title">操作指引</div>
        </template>
        <div class="instructions">

          <div class="instructionsList">
            <div class="item" v-for="(item, index) in instructionsList" :key="index">
              <div>
                <img class="img" :src="item.img" alt="" />

                <div class="itemTitle">
                  <span class="head-index">{{ index + 1 }} &nbsp;</span>{{ item.title }}
                </div>

                <div class="itemDescribe">{{ item.describe }}</div>
              </div>

              <i v-if="instructionsList.length!==index+1" class="el-icon-arrow-right" style="margin-left: 50px; font-size: 30px; font-weight: bolder;color:#b8babf"></i>
            </div>
          </div>
        </div>
      </el-collapse-item>
    </el-collapse>
    <div class="tableBox" :style="{ height: tableHeight }">
      <el-form ref="myDataSetPage" :model="myDataSetPage" label-width="75px" :size="defaultFormItemSize" label-position="right" @submit.native.prevent>
        <filter-box :item-width="350" @search="refresh()" @reset="onReset">
          <el-form-item label-width="0px">
            <el-button class="add" type="primary" icon="el-icon-plus" :size="defaultFormItemSize" @click="add">创建应用</el-button>
          </el-form-item>
          <el-form-item label="应用名称" prop="formFilter.modelName" label-width="120px">
            <el-input class="filter-item" v-model="myDataSetPage.formFilter.applicationName" :clearable="true" placeholder="应用名称" />
          </el-form-item>
        </filter-box>
      </el-form>

      <vxe-table border show-header-overflow show-overflow :row-config="{ isHover: true }" :data="myDataSetPage.tableData.impl.dataList" min-height="96">
        <vxe-column field="applicationName" title="应用名称"></vxe-column>
        <vxe-column field="appId" title="AppID"></vxe-column>
        <vxe-column field="apiKey" title="API Key"></vxe-column>
        <vxe-column field="secretKey" title="Secret Key"></vxe-column>
        <vxe-column field="applicationDescribe" title="描述"></vxe-column>
        <vxe-column field="createTime" title="创建时间"></vxe-column>
        <vxe-column field="operation" title="操作">
          <template slot-scope="scope">
            <!-- <el-button
                type="text"
                :size="defaultFormItemSize"
                @click="dataImport(scope.row)"
                >导入</el-button
              > -->
            <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button>
          </template>
        </vxe-column>
      </vxe-table>
      <el-row slot="pagination" type="flex" justify="end" style="margin-top: 16px;width: 100%;">
        <el-pagination :total="myDataSetPage.tableData.impl.totalCount" :current-page="myDataSetPage.tableData.impl.currentPage" :page-size="myDataSetPage.tableData.impl.pageSize" :page-sizes="[10, 20, 50, 100]" layout="total, prev, pager, next, sizes" @current-change="myDataSetPage.tableData.impl.onCurrentPageChange" @size-change="myDataSetPage.tableData.impl.onPageSizeChange">
        </el-pagination>
      </el-row>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
/* eslint-disable-next-line */
import { DropdownWidget, TableWidget, UploadWidget, ChartWidget } from '@/utils/widget.js'
import { applicationAccess } from '@/api/gptController.js'
import editOrAdd from './dialog/editOrAdd'
export default {
  data() {
    return {
      activeName: '1',
      collapseHeight: 0,
      instructionsList: [
        {
          title: '创建应用',
          describe: '创建应用, 获取密钥',
          img: require('@/assets/img/pg1.svg')
        },
        {
          title: '调用服务',
          describe: '查看请求示例, 调用服务',
          img: require('@/assets/img/pg2.svg')
        },
        {
          title: '查看用量',
          describe: '查看报表了解使用情况',
          img: require('@/assets/img/pg3.svg')
        }
      ],
      myDataSetPage: {
        formFilter: {
          applicationName: ''
        },

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    }
  },

  components: {},

  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight() {
      return this.getMainContextHeight - this.collapseHeight - 55 + 'px'
    }
  },

  methods: {
    getwidgetData(params) {
      if (params == null) params = {}
      params = {
        ...params,
        applicationAccessDtoFilter: { ...this.myDataSetPage.formFilter }
      }

      return new Promise((resolve, reject) => {
        applicationAccess
          .list(this, params)
          .then((res) => {
            resolve({
              dataList: res.data.dataList,
              totalCount: res.data.totalCount
            })
          })
          .catch((e) => {
            reject(e)
          })
      })
    },
    add() {
      this.$dialog
        .show(
          '创建应用',
          editOrAdd,
          {
            area: ['50%', '70%']
          },
          { isEdit: false }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {
          this.refresh()
        })
    },

    del(item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { kgId: item.kgId }
        applicationAccess
          .delete(this, params)
          .then((res) => {
            this.$message.success('删除成功')
            this.refresh()
          })
          .catch((e) => {
            console.log(e)
          })
      })
    },
    refresh(reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1)
      } else {
        this.myDataSetPage.tableData.impl.refreshTable()
      }
    },
    onReset() {
      this.$refs.myDataSetPage.resetFields()
      this.refresh(true)
    },
    formInit() {
      this.refresh()
    },
    resize(e) {
      setTimeout(() => {
        this.collapseHeight = e?.height
      }, 300)
    }
  },

  mounted() {
    this.formInit()
  }
}
</script>

<style lang="scss" scoped>
@import '@/assets/style/element-variables.scss';
.title {
  font-size: 16px;
}
.instructions {
  background-color: white;
  width: 100%;
  padding: 0px 20px 20px 20px;
  height: 180px;

  .instructionsList {
    display: flex;
    flex-direction: row;
    justify-content: space-around;
    .item {
      display: flex;
      align-items: center;
    }
  }
  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }
  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }
  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }
  .img {
    height: 72px;
    width: 140px;
  }
}
.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
div /deep/ .el-collapse-item__content {
  padding-bottom: 0;
}
div /deep/ .el-collapse-item__header {
  padding-left: 20px;
}
</style>
